using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;

using MSScriptControl;

namespace ScriptTest
{

	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	/// 

	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox tbScript;
		private System.Windows.Forms.Button btnEval;
		private System.Windows.Forms.Label lblError;

		private MSScriptControl.ScriptControlClass scriptEngine;
		private Test1 test1 = new Test1();

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			test1.t1 = "t1 value";
			test1.t2 = "t2 value";
			
			test1.hash.Add("username", "user123");

			//test1.hash.Values.Count
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.tbScript = new System.Windows.Forms.TextBox();
			this.btnEval = new System.Windows.Forms.Button();
			this.lblError = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(200, 264);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(64, 23);
			this.button1.TabIndex = 0;
			this.button1.Text = "Run";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// tbScript
			// 
			this.tbScript.Location = new System.Drawing.Point(8, 16);
			this.tbScript.Multiline = true;
			this.tbScript.Name = "tbScript";
			this.tbScript.Size = new System.Drawing.Size(432, 240);
			this.tbScript.TabIndex = 1;
			this.tbScript.Text = "";
			// 
			// btnEval
			// 
			this.btnEval.Location = new System.Drawing.Point(128, 264);
			this.btnEval.Name = "btnEval";
			this.btnEval.Size = new System.Drawing.Size(64, 23);
			this.btnEval.TabIndex = 2;
			this.btnEval.Text = "Eval";
			this.btnEval.Click += new System.EventHandler(this.btnEval_Click);
			// 
			// lblError
			// 
			this.lblError.Location = new System.Drawing.Point(16, 296);
			this.lblError.Name = "lblError";
			this.lblError.Size = new System.Drawing.Size(248, 32);
			this.lblError.TabIndex = 3;
			// 
			// Form1
			// 
			this.AcceptButton = this.button1;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(448, 333);
			this.Controls.Add(this.lblError);
			this.Controls.Add(this.btnEval);
			this.Controls.Add(this.tbScript);
			this.Controls.Add(this.button1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		public void hello(string msg) {
			//MessageBox.Show("MSG:c#: " + msg);
		
			Form2 f = new Form2();
			f.Show();


		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			scriptEngine = new ScriptControlClass();
			scriptEngine.Language = "JScript";

			//scriptEngine.AddCode("");
			
			StreamReader sr = File.OpenText("script.js");
			string fMsg = sr.ReadToEnd();
			sr.Close();

			scriptEngine.AddCode(fMsg);
			scriptEngine.AddObject("frm", this, true);
			scriptEngine.AddObject("tst", test1, true);
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			lblError.Text = "";
			try 
			{
				scriptEngine.ExecuteStatement(tbScript.Text);
			} 
			catch (Exception exc) {
				lblError.Text = exc.Message;
			}
		}

		private void btnEval_Click(object sender, System.EventArgs e)
		{
			lblError.Text = "";
			try 
			{
				tbScript.Text = scriptEngine.Eval(tbScript.Text).ToString();
			} 
			catch (Exception exc) 
			{
				lblError.Text = exc.Message;
			}
		}

		public class Test1 
		{
			public string t1;
			public string t2;

			public MyHashtable hash = new MyHashtable();
		}


	}

	public class MyHashtable : Hashtable 
	{

		public object Get(object key) 
		{
			return this[key];
		}
	}

}
